//
//  webSocketManager.h
//  双子星云手机
//
//  Created by xd h on 2024/6/20.
//

#import <Foundation/Foundation.h>
#import <RCCloudPhoneSDK/RCCommandChannel.h>
#import "AFNetworkReachabilityManager.h"
#import "backupsFileManager.h"
#import "uploadFileManager.h"
#import "downloadManager.h"
#import "downloadThumbnailManager.h"
#import "AudioSessionObject.h"
#import "commandSendCheckModel.h"
#import "RCCommandHelp.h"
#import "cloudPhoneCommonModel.h"
#import "couldPhoneBaseInfoModel.h"
#import "couldphoneSysInfoModel.h"
#import "TvStatusModel.h"
#import "couldPhoneCommonModel.h"
#import "extraMediaEventModel.h"


NS_ASSUME_NONNULL_BEGIN

@interface webSocketManager : NSObject
+(webSocketManager *)shareInstance;
@property (nonatomic, strong) RCCommandChannelManager *commandChannelManager;//指令通道

//上传文件用到
@property (nonatomic, copy) NSString * _Nullable taskUid;
@property (nonatomic, copy) NSString * _Nullable fileName;
@property (nonatomic, strong) NSData * _Nullable AllFileData;
@property (nonatomic, strong) NSMutableArray * _Nullable cutFileDataArr;
@property (nonatomic, assign) NSInteger indexOfUploadFlie;
@property (nonatomic, assign) NSInteger cutFileEachPieceSzie;
@property (nonatomic, strong) uploadFileDataModel *curUploadFileDataMod;
@property (nonatomic, assign) BOOL isSuspendUploadType;
@property (nonatomic, assign) long curUploadPostion;//当前上次片的位置

//下载文件用到
@property (nonatomic, copy) NSString * _Nullable downloadFileTaskUid;
@property (nonatomic, strong) couldPhoneFileModel *curDownloadFileModel;

//备份文件用到
@property (nonatomic, copy) NSString * _Nullable backupsTaskUid;
@property (nonatomic, copy) NSString * _Nullable backupsFileName;
@property (nonatomic, strong) NSData * _Nullable backupsAllFileData;
@property (nonatomic, strong) NSMutableArray * _Nullable backupsCutFileDataArr;
@property (nonatomic, assign) NSInteger backupsIndexOfUploadFlie;
//@property (nonatomic, assign) NSInteger cutFileEachPieceSzie;
@property (nonatomic, strong) photosBackupsTaskModel *curPhotosBackupsTaskMod;
@property (nonatomic, assign) long curBackupsPostion;//当前上次片的位置

//下载缩略图用到
@property (nonatomic, copy) NSString * _Nullable downloadThumbnailTaskUid;
@property (nonatomic, strong) couldPhoneFileModel *curDownloadThumbnailModel;


//链接websocket
- (void)opencommandChannelManagerrc_openURL;
- (void)WebSocketNeedRelinkFun;
//websocket 发消息
- (void)send_data:(NSString *)dataStr;

//创建备份文件夹
- (void)createBackupsFolderBy:(NSString*)backupsDefaultPath;
//获取备份文件夹列表
- (void)getBackupFolderListFun;
- (void)searchFileListBeginFun:(NSMutableDictionary *)dict;

#pragma mark 获取云机剩余空间
- (void)getBaseInfoFun;


//上传
- (void)beginGotoUploadFileFunBy:(uploadFileDataModel *)uploadFileDataMod;
- (void)suspendUploadFileFun;
//备份
- (void)beginGotoBackupsFileFunBy:(photosBackupsTaskModel *)photosBackupsTaskMod;
//下载缩略图
- (void)begindownloadThumbnailImageFunBy:(couldPhoneFileModel *)couldPhoneFileMod;
//下载
- (void)begindownloadFileFunBy:(couldPhoneFileModel *)couldPhoneFileMod;



- (void)handleDownloadResponseFunBy:(id)message;
- (void)downloadFileFunServiceResponseFun:(NSData *)fileData with:(BOOL)isDownloadDone;
- (void)downloadThumbnailFileFunServiceResponseFun:(NSData *)fileData with:(BOOL)isDownloadDone;
@end

NS_ASSUME_NONNULL_END
